;; beisp1.asm
.include "m2560def.inc"  ; Definitionen fuer den ATmega2560
; Reset and interrupt vectors ; Meaning
begin:  jmp main              ; Power On Reset
        jmp err_vect          ; External Int0 (INT0_vect)
        jmp err_vect          ; External Int1
        jmp err_vect          ; External Int2
        jmp err_vect          ; External Int3
        jmp err_vect          ; External Int4
        jmp err_vect          ; External Int5
        jmp err_vect          ; External Int6
        jmp err_vect          ; External Int7
        jmp err_vect          ; Pin Change Interrupt PCINT0
        jmp err_vect          ; Pin Change Interrupt PCINT1
        jmp err_vect          ; Pin Change Interrupt PCINT2
        jmp err_vect          ; Watchdog Time-out WDT
        jmp err_vect          ; Timer/Counter2 Compare Match A (TIMER2_COMPA_vect)
        jmp err_vect          ; Timer/Counter2 Compare Match B (TIMER2_COMPB_vect)
        jmp err_vect          ; Timer/Counter2 Overflow (TIMER2_OVF_vect)
        jmp err_vect          ; Timer/Counter1 Capture Event (TIMER1_CAPT_vect)
        jmp err_vect          ; Timer/Counter1 Compare Match A (TIMER1_COMPA_vect)
        jmp err_vect          ; Timer/Counter1 Compare Match B (TIMER1_COMPB_vect)
        jmp err_vect          ; Timer/Counter1 Compare Match C (TIMER1_COMPC_vect)
        jmp err_vect          ; Timer/Counter1 Overflow (TIMER1_OVF_vect)
        jmp err_vect          ; Timer/Counter0 Compare Match A (TIMER0_COMPA_vect)
        jmp err_vect          ; Timer/Counter0 Compare Match B (TIMER0_COMPB_vect)
        jmp err_vect          ; Timer/Counter0 Overflow (TIMER0_OVF_vect)
        jmp err_vect          ; SPI Serial Transfer Complete (SPI_STC_vect)
        jmp err_vect          ; USART0 Rx Complete (USART0_RX_vect)
        jmp err_vect          ; USART0 Data Register Empty (USART0_UDRE_vect)
        jmp err_vect          ; USART0 Tx Complete (USART0_TX_vect)
        jmp err_vect          ; Analog Comparator (ANALOG_COMP_vect)
        jmp err_vect          ; ADC Conversion Complete (ADC_vect)
        jmp err_vect          ; EEPROM Ready (EE_READY_vect)
        jmp err_vect          ; Timer/Counter3 Capture Event (TIMER3_CAPT_vect)
        jmp err_vect          ; Timer/Counter3 Compare Match A (TIMER3_COMPA_vect)
        jmp err_vect          ; Timer/Counter3 Compare Match B (TIMER3_COMPB_vect)
        jmp err_vect          ; Timer/Counter3 Compare Match C (TIMER3_COMPC_vect)
        jmp err_vect          ; Timer/Counter3 Overflow (TIMER3_OVF_vect)
        jmp err_vect          ; USART1 Rx Complete (USART1_RX_vect)
        jmp err_vect          ; USART1 Data Register Empty (USART1_UDRE_vect)
        jmp err_vect          ; USART1 Tx Complete (USART1_TX_vect)
        jmp err_vect          ; TWI (I2C) 2-wire Serial Interface (TWI_vect)
        jmp err_vect          ; Store Program Memory Ready (SPM_READY_vect)
        jmp err_vect          ; Timer/Counter4 Capture Event (TIMER4_CAPT_vect)
        jmp err_vect          ; Timer/Counter4 Compare Match A (TIMER4_COMPA_vect)
        jmp err_vect          ; Timer/Counter4 Compare Match B (TIMER4_COMPB_vect)
        jmp err_vect          ; Timer/Counter4 Compare Match C (TIMER4_COMPC_vect)
        jmp err_vect          ; Timer/Counter4 Overflow (TIMER4_OVF_vect)
        jmp err_vect          ; Timer/Counter5 Capture Event (TIMER5_CAPT_vect)
        jmp err_vect          ; Timer/Counter5 Compare Match A (TIMER5_COMPA_vect)
        jmp err_vect          ; Timer/Counter5 Compare Match B (TIMER5_COMPB_vect)
        jmp err_vect          ; Timer/Counter5 Compare Match C (TIMER5_COMPC_vect)
        jmp err_vect          ; Timer/Counter5 Overflow (TIMER5_OVF_vect)
        jmp err_vect          ; USART2 Rx Complete (USART2_RX_vect)
        jmp err_vect          ; USART2 Data Register Empty (USART2_UDRE_vect)
        jmp err_vect          ; USART2 Tx Complete (USART2_TX_vect)
        jmp err_vect          ; USART3 Rx Complete (USART3_RX_vect)
        jmp err_vect          ; USART3 Data Register Empty (USART3_UDRE_vect)
        jmp err_vect          ; USART3 Tx Complete (USART3_TX_vect)

err_vect:         ; do something when unexpected Interrupt occures
	push r16
	ldi r16, 0xFF
	sts DDRL, r16
	ldi r16, 0xAA
	sts PORTL, r16
	pop r16
	reti		; return from interrupt
;       jmp begin    ; or jump to make a reset

main:
	ldi r16, low(RAMEND)
	out SPL, r16	; Init Stackpointer L
	ldi r16, high(RAMEND)
	out SPH, r16	; Init Stackpointer H
	ldi r16, 0xFF    ;load immediate register16 with hexadezimal FF
        sts DDRL, r16    ;store to Data Direction Register L, will set all bits on PORTL aus output
        ldi r16, 0x07    ;lets select first 3 LEDs
mainloop:
        sts PORTL, r16   ;store to port L, will turn on some LEDs connected to PORTL
	clc		 ;clear carry
	rol r16		 ;rotate left
	brcc L1		 ;carry still clear?
	ori r16, 1	 ;no: set bit 0
L1:	rcall wait
	rjmp mainloop    ;relative jump back to label mainloop, will stay in ths loop for ever (until reset).

wait:	push r24
	push r25
	push r16
	ldi r16, 10
w1:	ldi r24, low(-32000)	;Registerpaar r25:r24 als 16-Bit Register verwenden
	ldi r25, high(-32000)	;Low Byte in r24, High Byte in r25
w2:	adiw r24, 1		;r25:r24 um 1 erhoehen
	brne w2			;Schlaufe 32000 mal ausfuehren
	dec r16
	brne w1			;make outer loop 10 times
	pop r16
	pop r25
	pop r24
	ret
